/*
Welcome to FinalFantasyFreak's Perspective Hearing Demo! (Known as 3D Sound to the makers of BYOND....)

Perspective Hearing is one of the newest additions to BYOND and it's just fantastic! It really gives
the programmers the freedom of the way they want players to hear their sound effects/music. And
while this ability is only extremely useful for sound effects at the moment and no midi it can
be used for both.

3D Sound is basically the way you hear things. For example, if in object in a game was about five
32x32 spaces to your right in a game and let's say it made a BOOM sound. In Old BYOND you'd hear
that sound as if it was right next to you, however, in the newer versions of BYOND, 3D Sound allows
you to make it actually sound as if it was to your right (only playing the sound on your right speaker)
and the volume will be less because it is a distance away from you. It really creates a
spectacular effect in games.

So enjoy my free demo! This is basically the best way to use it at the moment (it being 3D Sound).
*/

turf/Turf{icon='Turf.dmi'}
mob{icon='Mob.dmi'}

obj
	Music_Orb
		icon = 'Music Orb.dmi'
		density = 1
mob
	Login()
		usr.loc = locate(1,1,1)
		usr<<"This demo uses a Midi for the sound and, unfortunately, midi's cannot be continuously updateded live waves can for perspection. Therefore, simply move to an area you like and use the \"Music\" verb to have the midi begin playing. You can continue moving and restarting the midi by pressing \"Music\" again to get different views."
	verb
		Music()
			for(var/obj/Music_Orb/O in view(usr)) //No real use, just to search out the object for the persepective, read the log-in note.
				for(var/mob/M in view(O)) //If you want an actual mob/obj to play this automatically rather than the player having to hit a verb use for(var/mob/M in view(src)).
					var/t = sound('ff6rhap.mid', volume=100) //Midi's aren't ideal for 'Perspective Hearing.' Waves are instead, but Midi's can be used. BYOND now features a volume control, which is really nice.
					t:x += O:x-M.x //The "X" value in sound is whether the object is to your left or right. The equation O:x-M.x determines this. EX: Your X is 5 and the srcs X is 3 (to your left obviously). 3-5 = -2, and since negative numbers are left with this variable, the sound will be played on your left speaker. Positive numbers are played on your right speaker.
					//t:y = [Enter Number Here] <== I excluded this because the "Y" value in sound is whether or not the object is above your head or below you. Negative numbers are below you, positive numbers are above you.
					t:z += O:y-M.y //"Z" determines if the source is ahead or behind you. Positive numbers are ahead, negative numbers are behind. So O:y-M.y is the proper equation, EX: O:y=5, M.y=2. 5-2=3, so the source is infront of you and will sound like it in your speakers.
					t:environment = 8 //This isn't really for perspective. This is actually used to create sound effects. This particular one creates a concert-like effect. I will list all of the numbers below.
					M << t //This will play the modified sound.

/*
Environment Numbers: (1-25)

1. generic
2. padded cell
3. room
4. bathroom
5. livingroom
6. stoneroom
7. auditorium
8. concert hall
9. cave
10. arena
11. hangar
12. carpetted hallway
13. hallway
14. stone corridor
15. alley
15. forest
16. city
17. mountains
18. quarry
19. plain
20. parking lot
21. sewer pipe
22. underwater
23. rugged
24. dizzy
25. psychotic
*/